/**
 * 
 */
package mergesort;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author meder
 * 
 */
public final class IOHelper {
	private static final int MAX_ARRAY_SIZE = 8192;

	/**
	 * @return integer array
	 */
	public int[] getNextIntegerArray() {
		int[] result = null;
		String input = null;
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(
					System.in));
			input = in.readLine();
		} catch (IOException e) {
			e.printStackTrace();
		}

		if (null != input) {
			String[] inputArray = input.split(" ");
			result = new int[inputArray.length];
			for (int i = 0; i < result.length; i++) {
				result[i] = Integer.parseInt(inputArray[i]);
			}
		}		
		
		return result;
	}

	/**
	 * @return integer array
	 */
	public int[] getRandomIntegerArray() {
		int arraySize = (int) (Math.random() * MAX_ARRAY_SIZE);

		return getRandomIntegerArray(arraySize);
	}

	/**
	 * @param arraySize
	 *            size of generated integer array
	 * @return integer array with size arraySize
	 */
	public int[] getRandomIntegerArray(int arraySize) {
		int[] array = new int[arraySize];

		for (int i = 0; i < arraySize; i++) {
			array[i] = (int) (Math.random() * arraySize);
		}

		return array;
	}

	/**
	 * @param array
	 *            array to print on Standard Out
	 */
	public void printResult(int[] array) {
		if (null == array) {
			System.out.println("[ERROR] Array is NULL");
			return;
		}

		for (int i : array) {
			System.out.print(i + " ");
		}
		System.out.println();
	}
}
