/**
 * 
 */
package mergesort;

/**
 * @author meder
 * 
 */
public abstract class MergeSort {
	/**
	 * @param array
	 *            array to split
	 * @return splitted array
	 */
	protected final SplitArray split(int[] array) {
		return new SplitArray(array);
	}

	/**
	 * @param part1
	 *            left sub-array
	 * @param part2
	 *            right sub-array
	 * @return merged array
	 */
	protected final int[] merge(int[] part1, int[] part2) {
		int[] array = new int[part1.length + part2.length];
		int i1 = 0, i2 = 0;
		for (int k = 0; k < array.length;) {
			if ((i2 >= part2.length)
					|| (i1 < part1.length && part1[i1] <= part2[i2])) {
				array[k++] = part1[i1++];
			} else {
				array[k++] = part2[i2++];
			}
		}
		return array;
	}

	/**
	 * @param array
	 *            array to sort
	 * @return sorted array
	 */
	public abstract int[] sort(int[] array);
}
